import Styles from "@/constants/Styles";
import { apiDeleteLinkProject, apiGetProjectOne } from "@/lib/api";
import { urlCompleted } from "@/lib/fun_urlCompleted";
import { setUpdateProject } from "@/lib/projectUpdate";
import { useAuthSession } from "@/providers/AuthProvider";
import { useTheme } from "@/providers/ThemeProvider";
import { Feather, Ionicons } from "@expo/vector-icons";
import { useLocalSearchParams } from "expo-router";
import { useEffect, useState } from "react";
import { Linking, View } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";
import ModalConfirmation from "../ModalConfirmation";
import BorderBottomItem from "../borderBottomItem";
import DrawerBottom from "../drawerBottom";
import MenuItemRow from "../menuItemRow";
import Text from "../Text";


type Props = {
   id: string
   link: string
}

export default function SectionLink({ status, member, refreshing }: { status: number | undefined, member: boolean, refreshing?: boolean }) {
   const { colors } = useTheme();
   const entityUser = useSelector((state: any) => state.user)
   const [isModal, setModal] = useState(false)
   const { token, decryptToken } = useAuthSession();
   const { id } = useLocalSearchParams<{ id: string }>();
   const [data, setData] = useState<Props[]>([]);
   const update = useSelector((state: any) => state.projectUpdate)
   const dispatch = useDispatch()
   const [selectLink, setSelectLink] = useState<Props | null>(null)
   const [showDeleteModal, setShowDeleteModal] = useState(false)

   async function handleLoad() {
      try {
         const hasil = await decryptToken(String(token?.current));
         const response = await apiGetProjectOne({
            user: hasil,
            cat: "link",
            id: id,
         });
         setData(response.data);
      } catch (error) {
         console.error(error);
      }
   }

   useEffect(() => {
      handleLoad();
   }, [update.link]);

   useEffect(() => {
      if (refreshing)
         handleLoad();
   }, [refreshing]);


   async function handleDelete() {
      try {
         const hasil = await decryptToken(String(token?.current));
         const response = await apiDeleteLinkProject({ user: hasil, idLink: String(selectLink?.id) }, String(id));
         if (response.success) {
            Toast.show({ type: 'small', text1: 'Berhasil menghapus link', })
            dispatch(setUpdateProject({ ...update, link: !update.link }))
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error : any ) {
         console.error(error);
         const message = error?.response?.data?.message || "Gagal menghapus link"

         Toast.show({ type: 'small', text1: message })
      } finally {
         setModal(false)
      }
   }



   return (
      <>
         {
            data.length > 0 &&
            <>
               <View style={[Styles.mb15]}>
                  <Text style={[Styles.textDefaultSemiBold, Styles.mv05]}>Link</Text>
                  <View style={[Styles.wrapPaper, { backgroundColor: colors.card, borderColor: colors.background }]}>
                     {
                        data.map((item, index) => {
                           return (
                              <BorderBottomItem
                                 key={index}
                                 borderType="all"
                                 icon={<Feather name="link" size={25} color={colors.text} />}
                                 title={item.link}
                                 titleWeight="normal"
                                 onPress={() => { setSelectLink(item); setModal(true) }}
                              />
                           )
                        })
                     }
                  </View>
               </View>

               <DrawerBottom animation="slide" isVisible={isModal} setVisible={setModal} title="Menu">
                  <View style={Styles.rowItemsCenter}>
                     <MenuItemRow
                        icon={<Feather name="external-link" color={colors.text} size={25} />}
                        title="Buka Link"
                        onPress={() => {
                           Linking.openURL(urlCompleted(String(selectLink?.link)))
                        }}
                     />
                     {
                        !member && (entityUser.role == "user" || entityUser.role == "coadmin") ? <></>
                           :
                           <MenuItemRow
                              icon={<Ionicons name="trash-outline" color={colors.text} size={25} />}
                              title="Hapus"
                              disabled={status == 3}
                              onPress={() => {
                                 if (status == 3) return
                                 setModal(false)
                                 setTimeout(() => {
                                    setShowDeleteModal(true)
                                 }, 600)
                              }}
                           />
                     }
                  </View>
               </DrawerBottom>

               <ModalConfirmation
                  visible={showDeleteModal}
                  title="Konfirmasi"
                  message="Apakah Anda yakin ingin menghapus link ini? Link yang dihapus tidak dapat dikembalikan"
                  onConfirm={() => {
                     setShowDeleteModal(false)
                     handleDelete()
                  }}
                  onCancel={() => setShowDeleteModal(false)}
                  confirmText="Hapus"
                  cancelText="Batal"
               />
            </>
         }
      </>
   )
}